﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Text.RegularExpressions;

namespace Xprise.Xemod.Widgets
{
    public partial class CodeMaskTextBox : UserControl
    {
        private bool accept;
        private bool processed;

        public CodeMaskTextBox()
        {
            InitializeComponent();
        }

        public bool AcceptText
        {
            get
            {
                return accept;
            }
            set
            {
                accept = value;
            }
        }

        public bool Processed
        {
            get
            {
                return processed;
            }
            set
            {
                processed = value;
            }
        }

        public override string Text
        {
            get
            {
                return this.label1.Text + this.textBox1.Text;
            }
            set
            {
                string prefix = GetPrefix(value);
                string numericValue = GetNumericValue(value);

                this.label1.Text = prefix;
                this.textBox1.Text = numericValue;
            }
        }
        
        private string GetNumericValue(string value)
        {
            if (String.IsNullOrEmpty(value))
            {
                return "";
            }
            Match m = Regex.Match(value, @"^([A-Z](-)[A-T]*)(\d+)$", RegexOptions.IgnoreCase);

            string[] retVal = new string[m.Groups.Count - 1];

            for (int i = 1; i < m.Groups.Count; i++)
            {
                retVal[i - 1] = m.Groups[i].Value;
            }

            if (retVal.Length == 0)
            {
                return "";
            }

            return retVal[2];
        }

        private string GetPrefix(string value)
        {
            if (String.IsNullOrEmpty(value))
            {
                return "";
            }

            Match m = Regex.Match(value, @"^([A-T](-)[A-T]*)(\d+)$", RegexOptions.IgnoreCase);

            string[] retVal = new string[m.Groups.Count - 1];

            for (int i = 1; i < m.Groups.Count; i++)
            {
                retVal[i - 1] = m.Groups[i].Value;
            }

            if (retVal.Length == 0)
            {
                return "";
            }

            return retVal[0];
        }

        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Enter || e.KeyChar == (char)Keys.Escape)
            {
                this.OnKeyPress(e);
                return;
            }

            if (e.KeyChar == '0' || e.KeyChar == '1' || e.KeyChar == '2' ||
                e.KeyChar == '3' || e.KeyChar == '4' || e.KeyChar == '5' ||
                e.KeyChar == '6' || e.KeyChar == '7' || e.KeyChar == '8' ||
                e.KeyChar == '9')
            {
                this.OnKeyPress(e);
                return;
            }
            else
            {
                e.KeyChar = (char)Keys.None;
                this.OnKeyPress(e);
            }
        }
    }
}
